<!DOCTYPE html>
<!--AQ-->

<head>
    <html lang="en">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta charset="UTF-8">
    <title>Wireless connection</title>
    <link rel="stylesheet" type="text/css" href="../css/k2audio.css">

    </style>
    <script type="text/javascript" src="140medley.min.js"></script>
    <script type="text/javascript">
        var xhr = j();
        var currAp = "%currSsid%";

        function createInputForAp(ap) {
            if (ap.essid == "" && ap.rssi == 0) return;
            var div = document.createElement("div");
            div.id = "apdiv";
            var rssi = document.createElement("div");
            var rssiVal = -Math.floor(ap.rssi / 51) * 32;
            rssi.className = "icon";
            rssi.style.backgroundPosition = "0px " + rssiVal + "px";
            var encrypt = document.createElement("div");
            var encVal = "-64"; //assume wpa/wpa2
            if (ap.enc == "0") encVal = "0"; //open
            if (ap.enc == "1") encVal = "-32"; //wep
            encrypt.className = "icon";
            encrypt.style.backgroundPosition = "-32px " + encVal + "px";
            var input = document.createElement("input");
            input.type = "radio";
            input.name = "radio-essid";
            input.value = ap.essid;
            if (currAp != "" && currAp == ap.essid) input.checked = "1";
            input.id = "opt-" + ap.essid;
            input.addEventListener("change", () => {
                document.getElementById("txt_essid").value = ap.essid
            })
            var label = document.createElement("label");
            label.htmlFor = "opt-" + ap.essid;
            label.textContent = ap.essid;
            div.appendChild(input);
            div.appendChild(rssi);
            div.appendChild(encrypt);
            div.appendChild(label);
            return div;
        }

        function getSelectedEssid() {
            var e = document.forms.wifiform.elements;
            for (var i = 0; i < e.length; i++) {
                if (e[i].type == "radio" && e[i].checked) return e[i].value;
            }
            return currAp;
        }


        function scanAPs() {
            xhr.open("GET", "wifiscan.cgi");
            xhr.onreadystatechange = function() {
                if (xhr.readyState == 4 && xhr.status >= 200 && xhr.status < 300) {
                    var data = JSON.parse(xhr.responseText);
                    currAp = getSelectedEssid();
                    if (data.result.inProgress == "0" && data.result.APs.length > 1) {
                        $("#aps").innerHTML = "";
                        for (var i = 0; i < data.result.APs.length; i++) {
                            if (data.result.APs[i].essid == "" && data.result.APs[i].rssi == 0) continue;
                            $("#aps").appendChild(createInputForAp(data.result.APs[i]));
                        }
                        //window.setTimeout(scanAPs, 20000);
                    } else if (data.result.inProgress == "1") {
                        window.setTimeout(scanAPs, 1000);
                        $("#aps").innerHTML = "Scanning APs...";
                    } else { // some error..
                        $("#aps").innerHTML = "Allow a couple of seconds then press again to see results!";
                    }
                }
            }
            xhr.send();
        }

        

    </script>
</head>

<body>
    <article>
        <div class="header">
            <nav role="navigation" id="nav">
                <input class="trigger" type="checkbox" id="mainNavButton">
                <label for="mainNavButton" onclick>Menu</label>
                <ul>
                    <li><a href="../index.tpl">Home</a></li>
                    %menuWifi%
                    %menuOptions%
                    %menuFlash%
                    <li><a href="../reset.htm">Reset</a></li>
                    <li><a href="../protect/config.htm">Configuration</a></li>
                    %menuPassword%
                    %menuRS232%
                    %menuBrowser%
                    %menuRelays%
                </ul>
            </nav>
        </div>
        <main>
            <div class="optbox">
                <div class="container">
                    <div id="wrapper">
                        <div class="flex-container">
                            <div class="flex-item">

                                <h2>%hostname%</h2>
                                <h2>The current wireless mode is: %WiFiMode%</h2>
                                <h2>The current network name is: %currAp%</h2>
                                <p>
                                </p>
                                <form name="wifiform" action="connect.cgi" method="post">
                                    <p>
                                        Click scan to list the available wireless networks<br><br>
                                        <button id="scan-btn" type="button" onclick="scanAPs()">Scan!</button>
                                        <div id="aps"><i><small>In case of error or no results please wait at least 10 seconds before trying again.</i></small></div>
                                        <div> <br>
                                            Selected SSID: <br>
                                            <div class="inputboxes">
                                                <input type="text" name="essid" value="%currSsid%" id="txt_essid" class="inputbox"> </div><br>
                                            Password: <br>
                                            <div class="inputboxes">
                                                <input type="password" name="passwd" value="%WiFiPasswd%" id="txt_passwd" class="inputbox"> <br>
                                                <!--    <input type="submit" name="connect" value="Connect!">-->
                                            </div><br>
                                            <div>

                                                Select the preferred network, enter password if applicable and click "connect"
                                                <br> <br>

                                                <button><input type="submit" name="connect" class="buttons" value="Connect!"></button>


                                    </p>
                            </div>

                        </div>
                    </div>
                </div>
            </div>
            </div>
            </div>
        </main>
        <footer>Copyright &copy; 2019 &middot; All Rights Reserved &middot; Designed by K2Audio Ltd &middot;&nbsp;<a href="https://www.k2audio.co.uk" style="text-decoration: none">www.k2audio.co.uk</a>
            </div>

            <script src="/js/keene.js" type="text/javascript"></script>
           

        </footer>
    </article>

</body>

</html>
