/*
 Simple udp server
 */
#include<stdio.h> //printf
#include<string.h> //memset
#include<stdlib.h> //exit(0);
#include<arpa/inet.h>
#include "esp_err.h"
#include "esp_log.h"
#include<sys/socket.h>
#include "esp_event_loop.h"
#include "driver/uart.h"
#include <lwip/dns.h>

// #include <lwip/sockets.h>
#include "esp_wifi.h"

#include "k2audio.h"

#define PORT 30303   //should be 9761 for rs232 The port on which to listen for incoming data

#define BUF_SIZE (512)

static const char *TAG = "Discovery ";

void disc_rx_task(void *pvParameters) {

	uint8_t *dataPtr = (uint8_t*) malloc(BUF_SIZE);
	static int sd;

	static struct sockaddr_in si_me, si_other;
	int recv_len = -1;
	uint32_t slen = sizeof(si_other);

	uint8_t pos =0;
	uint8_t pos2;

	struct timeval read_timeout;
	read_timeout.tv_sec = 0;
	read_timeout.tv_usec = 100;
	bzero(dataPtr, BUF_SIZE);

	//RunFlags.pcip_acquired = false;
	sd = -1;
	while (!RunFlags.connected) {
		vTaskDelay(500 / portTICK_PERIOD_MS);
	}
	ESP_LOGI(TAG,"Discovery startup");

	while (1) {
		if (sd == -1) {
			// zero out the structure
			bzero((char *) &si_me, sizeof(si_me));
			//create a UDP socket
			if ((sd = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)) != -1) {
				int err = setsockopt(sd, SOL_SOCKET, SO_RCVTIMEO, (char*) &read_timeout, sizeof read_timeout);

				if (err < 0) {
					printf("Socket opt timeout fail %d \r\n", err);
				}
				err = setsockopt(sd, SOL_SOCKET, SO_BROADCAST, &broadcast, sizeof(broadcast));
				if (err < 0) {
					printf("Socket opt broadcast fail %d \r\n", err);
				}

				si_me.sin_family = AF_INET;
				si_me.sin_port = htons(PORT);
				si_me.sin_addr.s_addr = htonl(INADDR_ANY); // was INADDR_ANY
				//bind socket to port
				if (bind(sd, (struct sockaddr*) &si_me, sizeof(si_me)) == -1) {
					close(sd);
					perror("Disc bind error");
					sd = -1;
				}

			}
			si_other.sin_family = AF_INET;
			//ESP_LOGI(TAG,"Discovery socket %d \r\n", sd);

		}
		recv_len = -1;
		recv_len = recvfrom(sd, dataPtr, BUF_SIZE, 0, (struct sockaddr *) &si_other, &slen);
		//ESP_LOGI(TAG,"Discovery received %s",dataPtr);

		if (recv_len != -1) {
			// we have data
			///ESP_LOGI(TAG,"Data: %s ", dataPtr);

			if ((dataPtr[0] == 'd')&& (dataPtr[2] == 's') && (dataPtr[3] =='D')){
				// request for discovery data

				//print details of the client/peer and the data received

			//	ESP_LOGI(TAG,"Received packet from IP address %s on port: %d", inet_ntoa(si_other.sin_addr), ntohs(si_other.sin_port));
			//	ESP_LOGI(TAG,"Accepted as discovery request");

				bzero(dataPtr, BUF_SIZE);
				memcpy(&si_disc, &si_other, sizeof(si_other));
			//	if(!RunFlags.discoveryDataGenerated){
					buildDiscovery(0x01);
			//	}
				RunFlags.disc_acquired = true;
				RunFlags.discoveryDataGenerated = true;

			//	ESP_LOGI(TAG,"Discovery reply sent non broadcast");

				si_other.sin_port = htons(PORT);



				if (sendto(sd, &disc_data, dataLen, 0, (struct sockaddr*) &si_other, slen) == -1) {
					perror("sendto()");


				}

			}else if (recv_len > 5){
			//	ESP_LOGI(TAG,"Data is a discovery reply");
				pos = 0;
				while(1){
					pos++;
					if ((dataPtr[pos]== 0x0a)|| (dataPtr[pos]== 0x0d|| pos >16)){
						dataPtr[pos+1] = 0x00; // null string terminator
						break;

					}
					if (pos>0x80){
						break;
					}
				}
			//	ESP_LOGI(TAG,"pos = %d",pos);
				pos++; // *dataPtr[pos] = \n
				if (discoveryTotal < 20){
				strncpy((char*) discoveryList[discoveryTotal].name, (char*)dataPtr, pos ); // hostname
				}
				pos++; // *dataPtr[pos] = start of new string
				pos2 = pos;
				pos = 0;
			//	ESP_LOGI(TAG,"name copied as %s",discoveryList[discoveryTotal].name);

				while(1){
					pos++;
					if ((dataPtr[pos2 + pos]== 0x0a)|| (dataPtr[pos2 + pos]== 0x0d|| pos >16)){
						dataPtr[pos2 + pos +1] =0x00;
						break;
					}
					if (pos>0x80){
						break;
					}
				}


			//	ESP_LOGI(TAG,"pos2 = %d pos = %d",pos2, pos);
				if (discoveryTotal < 20){
				strncpy((char*)discoveryList[discoveryTotal].ipAddr, (char*) dataPtr + pos2, pos ); // IP address
				discoveryList[discoveryTotal].ipAddr[16] ='\r';
				discoveryList[discoveryTotal].ipAddr[17] ='\n';
				}
				pos2 = pos +pos2;
				pos =0;
				for (pos=0; pos<0x40; pos++){
					if ((dataPtr[pos2 + pos]== '0')&& (dataPtr[pos2 + pos +1]== '9')){
						inet_pton(AF_INET, discoveryList[discoveryTotal].ipAddr , &AppValues.target_addr.sin_addr.s_addr);

					}
				}

			//	ESP_LOGI(TAG,"IPaddress copied as %s",discoveryList[discoveryTotal].ipAddr);

				ESP_LOGI(TAG,"discovered module %s ", discoveryList[discoveryTotal].name);
				ESP_LOGI(TAG,"on IP address %s", discoveryList[discoveryTotal].ipAddr);
				discoveryTotal++;
				bzero(dataPtr, BUF_SIZE);


			}
		}

		vTaskDelay(100 / portTICK_PERIOD_MS);

	}

	close(sd);
	free(dataPtr);
	vTaskDelete( NULL);
}

void start_disc() {

}

void buildDiscovery(uint8_t type) {
	char string[32];
	int rows = 1;
	char ** Cptr = calloc(rows, sizeof(char*));
	char* txtPtr = (char*) &disc_data;
	uint8_t err;

	bzero(txtPtr, 300);
//	ESP_LOGI(TAG, "Discovery start");

	ip4_addr_t MyAddr;

	uint32_t len = (uint32_t) txtPtr;

	/*
	strcpy(txtPtr, "disA\r\n"); // discovery answer

	txtPtr+= 6;
	*/
	ESP_LOGI(TAG, "Discovery IP Address WifiCurrentMode = %d", AppValues.wifiCurrentMode);
	uint8_t MAC[6];
	uint8_t* MACPtr = (uint8_t*) MAC; // was &MAC

	tcpip_adapter_ip_info_t MyInfo;
	tcpip_adapter_dhcp_status_t MyDhcp;
	//tcpip_adapter_dns_info_t MyDns;

	ip_addr_t dnsserver;
	inet_pton(AF_INET, AppValues.DNS1, &dnsserver);
	dns_setserver(0, &dnsserver);
	inet_pton(AF_INET,AppValues.DNS2, &dnsserver);
	dns_setserver(1, &dnsserver);



	//hostname
	//ESP_LOGI(TAG, "Discovery hostname");


	if (AppValues.wifiCurrentMode == WIFI_MODE_AP) {
		err =tcpip_adapter_get_hostname(TCPIP_ADAPTER_IF_AP, (const char**) Cptr);
	} else if (AppValues.wifiCurrentMode == WIFI_MODE_APSTA) {
		err =tcpip_adapter_get_hostname(TCPIP_ADAPTER_IF_AP, (const char**) Cptr);
	}else if (AppValues.wifiCurrentMode == WIFI_MODE_STA){
		err =tcpip_adapter_get_hostname(TCPIP_ADAPTER_IF_STA, (const char**) Cptr);
	} else {
		err =tcpip_adapter_get_hostname(TCPIP_ADAPTER_IF_ETH, (const char**) Cptr);
	}



	if (err == ESP_OK){
		strcpy(string, *Cptr);
		strcpy(txtPtr, string);
		txtPtr = txtPtr + strlen(string);
		strcpy(txtPtr, "\r\n");
		txtPtr += 2;
	//	sprintf(AppValues.HOSTNAME, "%s", string);
	}else{
		ESP_LOGI(TAG,"Hostname error = %d wifi mode = %d",err, AppValues.wifiCurrentMode);
	}





	///IP address

	if (AppValues.wifiCurrentMode == WIFI_MODE_AP){
		err =tcpip_adapter_get_ip_info(TCPIP_ADAPTER_IF_AP, &MyInfo);
	}else if (AppValues.wifiCurrentMode ==WIFI_MODE_APSTA){
		err =tcpip_adapter_get_ip_info(TCPIP_ADAPTER_IF_AP, &MyInfo);
	} else if (AppValues.wifiCurrentMode == WIFI_MODE_STA){
		err =tcpip_adapter_get_ip_info(TCPIP_ADAPTER_IF_STA, &MyInfo);
	} else {
		err =tcpip_adapter_get_ip_info(TCPIP_ADAPTER_IF_ETH, &MyInfo);
	}

	if (err ==ESP_OK){
		sprintf(string, "%s", inet_ntoa(MyInfo.ip));
		//	ESP_LOGI(TAG, "IP addres = %s ", inet_ntoa(MyInfo.ip));
		strcpy(txtPtr, string);
		strcpy(AppValues.MyIp, string);
		txtPtr = txtPtr + strlen(string);
		strcpy(txtPtr, "\r\n");
		txtPtr += 2;
	}




	//MAC address
//	ESP_LOGI(TAG, "Discovery MAC address");

		if (AppValues.wifiCurrentMode == WIFI_MODE_AP) {
			err = esp_wifi_get_mac(WIFI_IF_AP, MACPtr);
		}else if(AppValues.wifiCurrentMode ==WIFI_MODE_APSTA){
			err = esp_wifi_get_mac(WIFI_IF_AP, MACPtr);
		}else if (AppValues.wifiCurrentMode == WIFI_MODE_STA) {
			err = esp_wifi_get_mac(WIFI_IF_STA, MACPtr);
		} else {
			err = esp_efuse_mac_get_default(MACPtr);
		}

	if (err ==ESP_OK){
		sprintf(string, "%02X:", MAC[0]);
		*(string + 2) = ':';
		sprintf((string + 3), "%02X", MAC[1]);
		*(string + 5) = ':';
		sprintf((string + 6), "%02X", MAC[2]);
		*(string + 8) = ':';
		sprintf((string + 9), "%02X", MAC[3]);
		*(string + 11) = ':';
		sprintf((string + 12), "%02X", MAC[4]);
		*(string + 14) = ':';
		sprintf((string + 15), "%02X", MAC[5]);
		*(string + 17) = 0x00;
		strcpy(txtPtr, string);
		memcpy(AppValues.MACAsString, string, 18);
		txtPtr = txtPtr + strlen(string);
		strcpy(txtPtr, "\r\n");
		txtPtr += 2;
	}

	//model eg K2wifi
	if (AppValues.currentMode == 1){
		strcpy(txtPtr, "08 = K2AUDIO ");
	} else if (AppValues.currentMode == 2){
		strcpy(txtPtr, "09 = K2AUDIO ");
	}else {
		strcpy(txtPtr, "10 = K2AUDIO ");
	}
	txtPtr += 13;
	strcpy(txtPtr, AppValues.deviceName);
	uint8_t slen = strlen(AppValues.deviceName);
	txtPtr += slen;
	strcpy(txtPtr, "\r\n");
	txtPtr += 2;



	sprintf(string, "IR port %d\r\n",AppValues.IR_PORT);
	strcpy(txtPtr,string);
	txtPtr += strlen(string);

	sprintf(string, "RS232 port %d\r\n",AppValues.RS_PORT);
	strcpy(txtPtr,string);
	txtPtr += strlen(string);


	//previous IP
	//ESP_LOGI(TAG, "Discovery last IP");
	if (AppValues.wifiCurrentMode == WIFI_MODE_AP){
		err = tcpip_adapter_get_old_ip_info(TCPIP_ADAPTER_IF_AP, &MyInfo);
	}else if (AppValues.wifiCurrentMode ==WIFI_MODE_APSTA){
		err = tcpip_adapter_get_old_ip_info(TCPIP_ADAPTER_IF_AP, &MyInfo);
	} else if (AppValues.wifiCurrentMode == WIFI_MODE_STA){
		err = tcpip_adapter_get_old_ip_info(TCPIP_ADAPTER_IF_STA, &MyInfo);
	} else {
		err = tcpip_adapter_get_old_ip_info(TCPIP_ADAPTER_IF_ETH, &MyInfo);
	}
	if(err == ESP_OK){
		sprintf(string, "Old IP %s", inet_ntoa(MyInfo.ip));
		strcpy(txtPtr, string);
		txtPtr = txtPtr + strlen(string);
		strcpy(txtPtr, "\r\n");
		txtPtr += 2;
	}

	//netmask
	sprintf(string, "Mask %s", inet_ntoa(MyInfo.netmask));
	strcpy(txtPtr, string);
	txtPtr = txtPtr + strlen(string);
	strcpy(txtPtr, "\r\n");
	sprintf(AppValues.Subnet, "%s", inet_ntoa(MyInfo.netmask));
	txtPtr += 2;

	//Gateway
	sprintf(string, "Gateway %s", inet_ntoa(MyInfo.gw));
	strcpy(txtPtr, string);
	txtPtr = txtPtr + strlen(string);
	strcpy(txtPtr, "\r\n");
	sprintf(AppValues.Gateway, "%s", inet_ntoa(MyInfo.gw));
	txtPtr += 2;

	// DNS1

	dnsserver = dns_getserver(0);
	MyAddr = dnsserver.u_addr.ip4;
	sprintf(string, "DNS 0 %s", inet_ntoa(MyAddr));
	strcpy(txtPtr, string);
	txtPtr = txtPtr + strlen(string);
	strcpy(txtPtr, "\r\n");
	sprintf(AppValues.DNS1, "%s", inet_ntoa(MyAddr));
	txtPtr += 2;

	//DNS2  ????
	dnsserver = dns_getserver(1);
	MyAddr = dnsserver.u_addr.ip4;
	sprintf(string, "DNS 1 %s", inet_ntoa(MyAddr));
	strcpy(txtPtr, string);
	txtPtr = txtPtr + strlen(string);
	strcpy(txtPtr, "\r\n");
	sprintf(AppValues.DNS2, "%s", inet_ntoa(MyAddr));
	txtPtr += 2;

	switch (AppValues.currentMode){

	case 1:
		//receiver
		//Target IP
		sprintf(string, "Target %s", inet_ntoa(AppValues.pc_addr.sin_addr));
		strcpy(txtPtr, string);
		txtPtr = txtPtr + strlen(string);
		strcpy(txtPtr, "\r\n");
		txtPtr += 2;


		break;
	case 2:
		// Target
		strcpy(txtPtr, "Module is a Target\r\n");
		txtPtr += 20;

		break;
	case 3 :
		break;
	default:
		//Target IP
		sprintf(string, "Target %s", inet_ntoa(AppValues.pc_addr.sin_addr));
		strcpy(txtPtr, string);
		txtPtr = txtPtr + strlen(string);
		strcpy(txtPtr, "\r\n");
		txtPtr += 2;
		break;
	}


	//PC IP
	sprintf(string, "PC %s", inet_ntoa(AppValues.target_addr.sin_addr));
	strcpy(txtPtr, string);
	txtPtr = txtPtr + strlen(string);
	strcpy(txtPtr, "\r\n");
	txtPtr += 2;


	//DHCP
//	ESP_LOGI(TAG, "Discovery DCHP");

	if (AppValues.wifiCurrentMode == WIFI_MODE_AP){
		err = tcpip_adapter_dhcpc_get_status(TCPIP_ADAPTER_IF_AP, &MyDhcp);
	}else if (AppValues.wifiCurrentMode ==WIFI_MODE_APSTA){
		err = tcpip_adapter_dhcpc_get_status(TCPIP_ADAPTER_IF_AP, &MyDhcp);
	} else if (AppValues.wifiCurrentMode == WIFI_MODE_STA) {
		err = tcpip_adapter_dhcpc_get_status(TCPIP_ADAPTER_IF_STA, &MyDhcp);
	} else {
		err = tcpip_adapter_dhcpc_get_status(TCPIP_ADAPTER_IF_ETH, &MyDhcp);
	}

	if (err == ESP_OK){
		if (MyDhcp == TCPIP_ADAPTER_DHCP_STARTED) {
			strcpy(txtPtr, "DHCP = ON \r\n");
			AppValues.STORED_FLAGS.useDHCP = true;
			txtPtr += 11;
		} else {
			strcpy(txtPtr, "DHCP = OFF\r\n");
			AppValues.STORED_FLAGS.useDHCP = false;
			txtPtr += 11;
		}
	}


	//DDNS
	//Firmware version

	strcpy(txtPtr, "Firmware = V1.0.0\r\n");
	txtPtr += 19;


	//user
		strcpy(txtPtr, AppValues.username);
		txtPtr = txtPtr + strlen(AppValues.username);
		strcpy(txtPtr, "\r\n");
		txtPtr += 2;

		//pass
		strcpy(txtPtr, AppValues.password);
		txtPtr = txtPtr + strlen(AppValues.password);
		strcpy(txtPtr, "\r\n");
		txtPtr += 2;


	// Disc text type

	if (type == 0x00) {
		strcpy(txtPtr, "Discovery info for K2audio Wireless Kira -> Boot\r\n\0");
		txtPtr += 51;
	} else {
		strcpy(txtPtr, "Discovery Reply K2audio Wireless Kira \r\n\0");
		txtPtr += 41;
	}





	dataLen = (uint32_t) txtPtr - len;

	//ESP_LOGI(TAG, "Data size = %d ", dataLen);

	free(Cptr);


}

