#include<stdio.h> //printf
#include<string.h> //memset
#include<stdlib.h> //exit(0);
#include<arpa/inet.h>
#include<sys/socket.h>
#include "esp_event_loop.h"
#include "driver/uart.h"
#include "esp_wifi.h"
#include "k2audio.h"

void setDefaults() {



	inet_pton(AF_INET, "192.168.4.1", &AppValues.target_addr.sin_addr.s_addr);
	inet_pton(AF_INET, "192.168.4.40", &AppValues.pc_addr.sin_addr.s_addr);
	inet_pton(AF_INET, "192.168.4.42", &AppValues.uart_addr.sin_addr.s_addr);
	AppValues.IR_PORT = 65432;



	AppValues.pc_addr.sin_port = htons(AppValues.IR_PORT);
	AppValues.target_addr.sin_port = htons(AppValues.IR_PORT);
	AppValues.uart_addr.sin_port = htons(AppValues.IR_PORT);

	AppValues.pc_addr.sin_family = AF_INET;
	AppValues.target_addr.sin_family = AF_INET;
	AppValues.uart_addr.sin_family = AF_INET;

	inet_pton(AF_INET, "8.8.8.8", &AppValues.DNS1);
	inet_pton(AF_INET, "8.8.4.4", &AppValues.DNS2);

	strcpy(version, "Firmware version = v1.3.04\r\n");

	inet_pton(AF_INET, "192.168.4.20", &AppValues.MyIp);
	inet_pton(AF_INET, "192.168.4.20", &AppValues.OldIP);
	inet_pton(AF_INET, "192.168.4.1", &AppValues.Gateway);
	inet_pton(AF_INET, "255.255.255.0", &AppValues.Subnet);
	strcpy(AppValues.HOSTNAME, "K2-Breakout-pcb");

	tcpip_adapter_set_hostname(TCPIP_ADAPTER_IF_STA, AppValues.HOSTNAME);
	tcpip_adapter_set_hostname(TCPIP_ADAPTER_IF_AP, AppValues.HOSTNAME);


	strcpy(AppValues.wifiSSID, "WIFI SSID");
	strcpy(AppValues.wifiPass, "WIFI PASS");
	AppValues.wifiStartMode = WIFI_MODE_STA;
	strcpy(AppValues.wifiAP_Name, "ESP32-HOME");

	strcpy(AppValues.deviceName, "Wireless Kira\r\n");




	AppValues.STORED_FLAGS.static_ip = false;
	AppValues.STORED_FLAGS.use_led = true;
	AppValues.STORED_FLAGS.useDHCP = true;


	AppValues.data_valid = 0xAA;
	AppValues.high_compensation = 1;
	AppValues.low_compensation = 1;

	AppValues.route_value = 0;
	AppValues.start_compensation = 1;

	strcpy(AppValues.password, "K2AUDIO!");
	strcpy(AppValues.username, "admin");


	AppValues.STORED_FLAGS.gpio_use_for_display = true ;
	AppValues.STORED_FLAGS.gpio_use_for_i2c = true;

	AppValues.GPIOS.gpio_00_pulsed = true;
	AppValues.GPIOS.gpio_05_pulsed = true;
	AppValues.GPIOS.gpio_13_pulsed = true;
	AppValues.GPIOS.gpio_14_pulsed = true;
	AppValues.GPIOS.gpio_15_pulsed = true;
	AppValues.GPIOS.gpio_19_pulsed = true;
	AppValues.GPIOS.gpio_22_pulsed = true;
	AppValues.GPIOS.gpio_23_pulsed = true;
	AppValues.GPIOS.gpio_04_pulsed = true;
	AppValues.GPIOS.gpio_12_pulsed = true;
	AppValues.GPIOS.gpio_16_pulsed = true;
	AppValues.GPIOS.gpio_17_pulsed = true;
	AppValues.GPIOS.gpio_18_pulsed = true;
	AppValues.GPIOS.gpio_23_pulsed = true;
	AppValues.GPIOS.gpio_25_pulsed = true;
	AppValues.GPIOS.gpio_26_pulsed = true;
	AppValues.GPIOS.gpio_27_pulsed = true;
	AppValues.GPIOS.gpio_32_pulsed = true;
	AppValues.GPIOS.gpio_33_pulsed = true;

	AppValues.GPIOS.gpio_00_state = 0;
	AppValues.GPIOS.gpio_05_state = 0;
	AppValues.GPIOS.gpio_13_state = 0;
	AppValues.GPIOS.gpio_14_state = 0;
	AppValues.GPIOS.gpio_15_state = 0;
	AppValues.GPIOS.gpio_19_state = 0;
	AppValues.GPIOS.gpio_21_state = 0;
	AppValues.GPIOS.gpio_22_state = 0;
	AppValues.GPIOS.gpio_04_state = 0;
	AppValues.GPIOS.gpio_12_state = 0;
	AppValues.GPIOS.gpio_16_state = 0;
	AppValues.GPIOS.gpio_17_state = 0;
	AppValues.GPIOS.gpio_18_state = 0;
	AppValues.GPIOS.gpio_23_state = 0;
	AppValues.GPIOS.gpio_25_state = 0;
	AppValues.GPIOS.gpio_26_state = 0;
	AppValues.GPIOS.gpio_27_state = 0;
	AppValues.GPIOS.gpio_32_state = 0;
	AppValues.GPIOS.gpio_33_state = 0;





	RunFlags.debug = true;
	RunFlags.IR_TX_dataReady = false;
	RunFlags.IR_ST_dataReady = false;
	RunFlags.connected = false;
	RunFlags.pcip_acquired = false;
	RunFlags.targetip_acquired = true;
	RunFlags.udpDataReady = false;
	RunFlags.udp2DataReady = false;
	RunFlags.discDataReady = false;
	RunFlags.disc_acquired = false;
	RunFlags.matchFound = false;
	RunFlags.matchIRinUse = false;
	RunFlags.is_cmdS = false;
	RunFlags.appValuesChanged = false;
	RunFlags.saveInProgress = false;
	RunFlags.resetRequired = false;
	RunFlags.displayUpdated = false;

}
