/*
 Simple udp server
 */
#include<stdio.h> //printf
#include<string.h> //memset
#include<stdlib.h> //exit(0);
#include<arpa/inet.h>
#include<sys/socket.h>
#include "esp_err.h"
#include "esp_log.h"
#include "esp_event_loop.h"
#include "driver/uart.h"

#include "k2audio.h"

#define BUF_SIZE (512)

static const char *TAG = "UDP_TX";

void udp_tx_task(void *pvParameters) {

	static int s;



	static struct sockaddr_in si_me, si_other;
	uint32_t slen = sizeof(si_me);

	struct timeval read_timeout;
	read_timeout.tv_sec = 0;
	read_timeout.tv_usec = 100;

	RunFlags.udpDataReady = false;
	RunFlags.pcip_acquired = false;
	s = -1;
	while(!RunFlags.connected){
		vTaskDelay(500 / portTICK_PERIOD_MS);
	}

	while (1) {
		while (s == -1) {

			// zero out the structure
			bzero((char *) &si_me, sizeof(si_me));
			//create a UDP socket
			if ((s = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)) != -1) {
				int err = setsockopt(s, SOL_SOCKET, SO_RCVTIMEO, (char*) &read_timeout, sizeof read_timeout);
				if (err < 0) {
					perror("Socket opt fail ");
				}
				si_me.sin_family = AF_INET;
				si_me.sin_port = htons(AppValues.IR_PORT);
				si_me.sin_addr.s_addr = htonl(INADDR_ANY);
			}
		//	ESP_LOGI(TAG,"UDP Tx S = %d \r\n", s);

		}

		if (s != -1) {

			if ((RunFlags.udpDataReady) || (RunFlags.udp2DataReady)) {
				//todo lose one of these.
				/// either or both
				if (RunFlags.pcip_acquired) {
					// send new data if remote has been in touch.
					memcpy(&si_other, &AppValues.pc_addr, sizeof(si_other));
					//ESP_LOGI(TAG,"UDP 1 send to  %s:%d\r\n",  inet_ntoa(AppValues.dest1.sin_addr), ntohs(AppValues.dest1.sin_port));
					if (sendto(s, udp_send_data, udp_data_length, 0, (struct sockaddr*) &si_other, slen) == -1) {
						perror("UDP sendto()");
					}
					ESP_LOGI(TAG,"UDP 1 data sent to  %s:%d\r\n",  inet_ntoa(si_other.sin_addr), ntohs(si_other.sin_port));
				}
				if (RunFlags.targetip_acquired) {
					// send new data if remote has been in touch.
					memcpy(&si_other, &AppValues.target_addr, sizeof(si_other));
				//	ESP_LOGI(TAG,"UDP 2 send to  %s:%d\r\n",  inet_ntoa(AppValues.dest2.sin_addr), ntohs(si_other.sin_port));
					if (sendto(s, udp_send_data, 0x300, 0, (struct sockaddr*) &si_other, slen) == -1) {
						perror("UDP2 sendto()");
					}
					ESP_LOGI(TAG,"UDP 2 data sent to  %s:%d\r\n",  inet_ntoa(si_other.sin_addr), ntohs(si_other.sin_port));
				}
				RunFlags.udp2DataReady = false;
				RunFlags.udpDataReady = false;

				bzero(udp_send_data, 0x300);
			}

			if (RunFlags.discDataReady) {

				if (!RunFlags.disc_acquired) {
					// if no one talking to us send as broadcast
					int err = setsockopt(s, SOL_SOCKET, SO_BROADCAST, &broadcast, sizeof(broadcast));
					if (err == -1) {
						perror("Disc2 sendto()");
					}
					si_disc.sin_addr.s_addr = INADDR_BROADCAST;

				}
				si_disc.sin_port = htons(30303);
				si_disc.sin_family = AF_INET;

				if ( si_disc.sin_addr.s_addr ==0x00){
					si_disc.sin_addr.s_addr = INADDR_BROADCAST;
				}

				if (sendto(s, &disc_data, dataLen, 0, (struct sockaddr*) &si_disc, slen) == -1) {
					perror("Disc sendto()");
				}
				RunFlags.discDataReady = false;


			}

			vTaskDelay(50 / portTICK_PERIOD_MS);
		}
	}

	close(s);
	vTaskDelete( NULL);
}

void setDataReady() {
	RunFlags.udpDataReady = true;

}

void setData2Ready() {
	RunFlags.targetip_acquired = true;
	RunFlags.udp2DataReady = true;
}

