#include <stdio.h>
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include "esp_system.h"
#include "driver/gpio.h"
#include "k2audio.h"

struct sockaddr_in si_disc;
struct sockaddr_in si_rs232;

uint8_t  LEDStatus;
uint8_t AsciiData[0x300];
uint8_t udp_send_data[0x300];
uint8_t disc_data[0x300];
uint8_t udp_rec_data[0x300];  // incoming or ougoing dat for udp socket


rmt_item32_t rmtItem[0x100];
rmt_item32_t rec_IR_data[0x80];

uint16_t dataLen = 0x200;
uint16_t udp_data_length = 0x300;



uint8_t discoveryTotal;
char version[32];

int pairCount;
int frequency;
int storedPairCount;
int locationNumber;
int RS232_DataSize;


bool mDnsisUp = false;
bool debug = true;
//bool debug = false;

char Gateway[16] = "192.168.24.1";
char Subnet[16] = "255.255.255.0";
char IPaddress[16] = "192.168.24.1";
char codeName[24] = "LocationEmpty";
char debugInfo[48];
int broadcast = 1;


QueueHandle_t uart_queue;

//***************helpers******************************************

uint8_t ascii2hex(uint8_t lowByte, uint8_t highByte) {
	uint8_t rtn;
	rtn = ascii2hexSingle(highByte);
	rtn = rtn << 4;
	rtn = rtn + ascii2hexSingle(lowByte);

	return rtn;
}

uint8_t ascii2hexSingle(uint8_t ascChr) {
	{
		if (ascChr > 'F') {
			ascChr -= 32; // 'a' to 'f'  make upper case
		}
		if (ascChr > '9') {
			ascChr += 9;

		}
		return (ascChr &= 0x0F);
	}
}

void byteToAsciiHex(uint8_t num, char* store) {

	uint8_t tmp;

	tmp = num & 0xF0;

	tmp = tmp >> 4;

	if (tmp > 0x09) {
		tmp = tmp + 7;
	}

	tmp = tmp + '0';

	*store++ = tmp;

	tmp = num & 0x0F;

	if (tmp > 0x09) {

		tmp = tmp + 7;
	}

	tmp = tmp + '0';
	*store = tmp;

}


