/**
 * @file symon.h
 *
 */

#ifndef SYSMON_H
#define SYSMON_H

#ifdef __cplusplus
extern "C" {
#endif

/*********************
 *      INCLUDES
 *********************/
#ifdef LV_CONF_INCLUDE_SIMPLE
#include "lvgl.h"
#include "lv_ex_conf.h"
#else
#include "../components/lvgl/lvgl.h"
#include "../components/lv_ex_conf.h"
#endif


/*********************
 *      DEFINES
 *********************/

/**********************
 *      TYPEDEFS
 **********************/



/**********************
 * GLOBAL PROTOTYPES
 **********************/

/**
 * Initialize the system monitor
 */
void display_create(void);
void updateRssi(uint8_t rssi);
void create_new_button(void);
void setDisplayTxt(void);
void insertDisplayTxt(char *txt, uint8_t size, uint8_t pos) ;
uint16_t willTxtFit(char *txt);


extern uint8_t isPlaying;


/**********************
 *      MACROS
 **********************/



#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* SYSMON_H */
