/*
 * hardware.c
 *
 *  Created on: 4 Sep 2018
 *      Author: mark
 */

#include<stdio.h> //printf
#include<string.h> //memset
#include<stdlib.h> //exit(0);
#include<arpa/inet.h>
#include "esp_err.h"
#include "esp_log.h"
#include<sys/socket.h>
#include "esp_event_loop.h"
#include "driver/uart.h"
#include <lwip/dns.h>
#include "k2audio.h"

// in k2audio.h
/*


 #define STATUS_GPIO GPIO_NUM_2
 #define MODE_GPIO GPIO_NUM_26
 #define USE_MODE_SELECT GPIO_NUM_27
 #define USE_RESET  GPIO_NUM_25
 #define enRS232 GPIO_NUM_22
 #define enKCC GPIO_NUM_32
 #define ACK_LED GPIO_NUM_35
 #define KCC_OUT1 GPIO_NUM_39
 #define KCC_OUT2 GPIO_NUM_36
 #define IR_OUT1	GPIO_NUM_19
 #define IR_OUT2	GPIO_NUM_23
 #define IR_IN_DEMOD GPIO_NUM_18

 */

#define TAG "ports"

void initPorts() {



	if(AppValues.STORED_FLAGS.gpio_use_for_display== false){
		gpio_pad_select_gpio(GPIO_NUM_14);
		gpio_set_pull_mode(GPIO_NUM_14, GPIO_PULLUP_ONLY);
		gpio_pullup_en(GPIO_NUM_14);
		gpio_set_direction(GPIO_NUM_14, GPIO_MODE_OUTPUT);

		gpio_pad_select_gpio(GPIO_NUM_13);
		gpio_set_pull_mode(GPIO_NUM_13, GPIO_PULLUP_ONLY);
		gpio_pullup_en(GPIO_NUM_13);
		gpio_set_direction(GPIO_NUM_13, GPIO_MODE_OUTPUT);

		gpio_pad_select_gpio(GPIO_NUM_15);
		gpio_set_pull_mode(GPIO_NUM_15, GPIO_PULLUP_ONLY);
		gpio_pullup_en(GPIO_NUM_15);
		gpio_set_direction(GPIO_NUM_15, GPIO_MODE_OUTPUT);

		gpio_pad_select_gpio(GPIO_NUM_19);
		gpio_set_pull_mode(GPIO_NUM_19, GPIO_PULLUP_ONLY);
		gpio_pullup_en(GPIO_NUM_19);
		gpio_set_direction(GPIO_NUM_19, GPIO_MODE_OUTPUT);

		gpio_pad_select_gpio(GPIO_NUM_5);
		gpio_set_pull_mode(GPIO_NUM_5, GPIO_PULLUP_ONLY);
		gpio_pullup_en(GPIO_NUM_5);
		gpio_set_direction(GPIO_NUM_5, GPIO_MODE_OUTPUT);


		gpio_pad_select_gpio(GPIO_NUM_0);
		gpio_set_pull_mode(GPIO_NUM_0, GPIO_PULLUP_ONLY);
		gpio_pullup_en(GPIO_NUM_0);
		gpio_set_direction(GPIO_NUM_0, GPIO_MODE_OUTPUT);

	}

	if(AppValues.STORED_FLAGS.gpio_use_for_i2c == false){
		gpio_pad_select_gpio(GPIO_NUM_22);
		gpio_set_pull_mode(GPIO_NUM_22, GPIO_PULLUP_ONLY);
		gpio_pullup_en(GPIO_NUM_22);
		gpio_set_direction(GPIO_NUM_22, GPIO_MODE_OUTPUT);

		gpio_pad_select_gpio(GPIO_NUM_21);
		gpio_set_pull_mode(GPIO_NUM_21, GPIO_PULLUP_ONLY);
		gpio_pullup_en(GPIO_NUM_21);
		gpio_set_direction(GPIO_NUM_21, GPIO_MODE_OUTPUT);
	}

	gpio_pad_select_gpio(GPIO_NUM_4);
	gpio_set_pull_mode(GPIO_NUM_4, GPIO_PULLUP_ONLY);
	gpio_pullup_en(GPIO_NUM_4);
	gpio_set_direction(GPIO_NUM_4, GPIO_MODE_OUTPUT);

	gpio_pad_select_gpio(GPIO_NUM_16);
	gpio_set_pull_mode(GPIO_NUM_16, GPIO_PULLUP_ONLY);
	gpio_pullup_en(GPIO_NUM_16);
	gpio_set_direction(GPIO_NUM_16, GPIO_MODE_OUTPUT);

	gpio_pad_select_gpio(GPIO_NUM_17);
	gpio_set_pull_mode(GPIO_NUM_17, GPIO_PULLUP_ONLY);
	gpio_pullup_en(GPIO_NUM_17);
	gpio_set_direction(GPIO_NUM_17, GPIO_MODE_OUTPUT);

	gpio_pad_select_gpio(GPIO_NUM_18);
	gpio_set_pull_mode(GPIO_NUM_18, GPIO_PULLUP_ONLY);
	gpio_pullup_en(GPIO_NUM_18);
	gpio_set_direction(GPIO_NUM_18, GPIO_MODE_OUTPUT);

/*  used as IR blaster
	gpio_pad_select_gpio(GPIO_NUM_23);
	gpio_set_pull_mode(GPIO_NUM_23, GPIO_PULLUP_ONLY);
	gpio_pullup_en(GPIO_NUM_23);
	gpio_set_direction(GPIO_NUM_23, GPIO_MODE_OUTPUT);
	*/

	gpio_pad_select_gpio(GPIO_NUM_25);
	gpio_set_pull_mode(GPIO_NUM_25, GPIO_PULLUP_ONLY);
	gpio_pullup_en(GPIO_NUM_25);
	gpio_set_direction(GPIO_NUM_25, GPIO_MODE_OUTPUT);


	gpio_pad_select_gpio(GPIO_NUM_26);
	gpio_set_pull_mode(GPIO_NUM_26, GPIO_PULLUP_ONLY);
	gpio_pullup_en(GPIO_NUM_26);
	gpio_set_direction(GPIO_NUM_26, GPIO_MODE_OUTPUT);

	gpio_pad_select_gpio(GPIO_NUM_27);
	gpio_set_pull_mode(GPIO_NUM_27, GPIO_PULLUP_ONLY);
	gpio_pullup_en(GPIO_NUM_27);
	gpio_set_direction(GPIO_NUM_27, GPIO_MODE_OUTPUT);

	gpio_pad_select_gpio(GPIO_NUM_32);
	gpio_set_pull_mode(GPIO_NUM_32, GPIO_PULLUP_ONLY);
	gpio_pullup_en(GPIO_NUM_32);
	gpio_set_direction(GPIO_NUM_32, GPIO_MODE_OUTPUT);

	gpio_pad_select_gpio(GPIO_NUM_33);
	gpio_set_pull_mode(GPIO_NUM_33, GPIO_PULLUP_ONLY);
	gpio_pullup_en(GPIO_NUM_33);
	gpio_set_direction(GPIO_NUM_33, GPIO_MODE_OUTPUT);


	gpio_pad_select_gpio(GPIO_NUM_12);
	gpio_set_pull_mode(GPIO_NUM_12, GPIO_PULLUP_ONLY);
	gpio_pullup_en(GPIO_NUM_12);
	gpio_set_direction(GPIO_NUM_12, GPIO_MODE_OUTPUT);


	gpio_pad_select_gpio(IR_INPUT);
	gpio_set_pull_mode(IR_INPUT, GPIO_PULLDOWN_ONLY);
	gpio_pullup_en(IR_INPUT);
	gpio_set_direction(IR_INPUT, GPIO_MODE_INPUT);
	//printf("PULLDOWN SET\r\n");

	gpio_pad_select_gpio(STATUS_GPIO);
	gpio_set_pull_mode(STATUS_GPIO, GPIO_PULLDOWN_ONLY);
	gpio_pullup_en(STATUS_GPIO);
	gpio_set_direction(STATUS_GPIO, GPIO_MODE_OUTPUT);

}

