#include <stdio.h>
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include "esp_task_wdt.h"
#include "esp_system.h"
#include "driver/gpio.h"
#include "esp_err.h"
#include "esp_log.h"
#include "k2audio.h"

#define TAG "start_mode"


void setStartUpMode() {

	setDefaults(); // just to make sure we set the default values for RunFlags etc even if using AppValues


	bool dataGood = loadAppValues();


	if (gpio_get_level(IR_INPUT)== 0){
		AppValues.data_valid = 0xFF;
	}
	//ESP_LOGI(TAG,"AppValues.data_valid = 0%X", AppValues.data_valid);
	if (AppValues.data_valid != 0xAA){
		dataGood = false;
	}

	if (!dataGood) {
		setDefaults(); // this should set data_valid to 0xAA;
		dataGood = saveAppValues();

		if (!dataGood) {
			ESP_LOGI(TAG, "FileSystem fail \r\n");
		} else {
			ESP_LOGI(TAG, "Defaults used\r\n");
		}
		// default to AP
		strcpy(AppValues.wifiSSID, "ESP32-HOME");
		strcpy(AppValues.wifiPass, "K2AUDIO!");
		strcpy(AppValues.wifiAP_Name, "ESP32-HOME");
		AppValues.wifiStartMode = WIFI_MODE_AP;
		AppValues.currentMode =0x01;


	} else {
		ESP_LOGI(TAG, "AppValues file loaded OK, and mode = %d ", AppValues.currentMode);
	}




}
